; TC_TEXT.ASM - ASSEMBLY INTERFACE FUNCTIONS FOR TURBO C
 PUBLIC _CLRSCRN, _WAIT, _GETTIME, _BEEP
_TEXT   SEGMENT BYTE PUBLIC 'CODE'
           ASSUME CS:_TEXT
_CLRSCRN PROC NEAR
         PUSH AX
         PUSH BX
         MOV  AH,15
         INT  10H
         MOV  AH,0
         INT  10H
         POP  BX
         POP  AX
         RET
_CLRSCRN ENDP

_WAIT  PROC NEAR
       PUSH AX
       PUSH BX           ; SAVE AFFECTED REGISTERS
       PUSH CX
       PUSH DX
       MOV  CL,0         ; SET MINUTES TO ZERO
       MOV  DH,3         ; SET SECONDS TO THREE
       MOV  DL,0         ; SET THOUSAND-SECONDS TO ZERO
SAVEINS: MOV  AL,CL       ; MOVE INPUT MINS TO AL,
       MOV  BX,DX         ;  SECS AND HUNDS TO BX
       SUB  AH,AH         ; SET THE HOURS COUNT TO 0
       CALL _GETTIME       ; READ THE TIME
       ADD  BL,DL         ; CALCULATE THE TARGET TIME
       CMP  BL,100
       JB   SECT
       SUB  BL,100
       INC  BH
SECT:  ADD  BH,DH
       CMP  BH,60
       JB   MINT
       SUB  BH,60
       INC  AL
MINT:  ADD  AL,CL
       CMP  AL,60
       JB   HRT
       SUB  AL,60
       INC  AH
HRT:   ADD  AH,CH
       CMP  AH,24
       JB   WAIT
       SUB  AH,24
WAIT:  CALL _GETTIME       ; READ THE TIME AGAIN
       CMP  CH,AH         ; COMPARE HOURS,
       JNE  WAIT
       CMP  CL,AL         ; MINUTES
       JB   WAIT
       JA   CLRAL
       CMP  DX,BX         ; SECONDS AND HUNDREDTHS
       JB   WAIT
CLRAL: MOV  AL,0          ; THE TIMES MATCH, SET AL = 0
LEAVE: POP  DX            ; RESTORE REGISTERS
       POP  CX
       POP  BX
       POP  AX
       RET               ; RETURN TO CALLING PROGRAM
_WAIT  ENDP

_GETTIME  PROC NEAR
          PUSH AX           ; SAVE AX ON THE STACK
          MOV  AH,2CH       ; CALL DOS FUNCTION 2CH
          INT  21H
          POP  AX           ; RETRIEVE ORGINAL AX
          RET               ; RETURN TO CALLING PROGRAM
_GETTIME  ENDP

_BEEP    PROC NEAR
         PUSH AX
         PUSH DX
         MOV  DL,7           ; LOAD BEEP CHARACTER INTO DL
         MOV  AH,2           ; AND CALL DOS FUNCTION 2
         INT  21H
         POP  DX
         POP  AX
         RET
_BEEP    ENDP

_TEXT    ENDS

DGROUP   GROUP  _DATA, _BSS
           ASSUME DS:DGROUP
_DATA    SEGMENT WORD PUBLIC 'DATA'

_DATA    ENDS

_BSS     SEGMENT WORD PUBLIC 'BSS'

_BSS     ENDS
         END
